import os
import numpy as np
import matplotlib.pyplot as plt
import sys
from math import cos
import csv
import re
import time
import os


from PyQt5.QtWidgets import *
from PyQt5.QtGui import *
from PyQt5.QtCore import *

import sys
 
from PyQt5.QtWidgets import QApplication, QMainWindow, QMenu, QVBoxLayout, QSizePolicy, QMessageBox, QWidget, QPushButton
from PyQt5.QtGui import QIcon
 
 
from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg as FigureCanvas
from matplotlib.backends.backend_qt5agg import NavigationToolbar2QT as NavigationToolbar

from matplotlib.figure import Figure
import matplotlib.pyplot as plt
 
import random

def dataExtract(path): 
    graphcount=0
    data=[]

    with open(path,'r') as csvfile:
        tablereader = csv.reader(csvfile, delimiter=' ',quotechar='|')
        for row in tablereader:
            data.append(row)

    for k in range (0,len(data)-1):
        if data[k]==[]:
            del data[k]
        if re.compile('mean',re.IGNORECASE).match(str(data[k][0])) != None:
            graphcount+=1
    

    for k in range(0,len(data)):
        data[k] = data[k][0].split(';')
        
        for i in range(0,len(data[k])-1): #TODO est-ce que il n'y a toujours du texte qu'en début de ligne ??
            if re.compile('\D',re.IGNORECASE).match(data[k][i]):
                del data[k][i]
    

    for k in range(0,len(data)):
        for i in range (0,len(data[k])):
            data[k][i] = float(data[k][i])
        

    return (data,graphcount)
    

class PlotCanvas(FigureCanvas):
 
    def __init__(self, parent=None, width=5, height=4, dpi=100, title="", data=[]):
        
        fig = Figure(figsize=(width, height), dpi=dpi)
        self.axes = fig.add_subplot(111)
        FigureCanvas.__init__(self, fig)
        self.setParent(parent)
        
        FigureCanvas.setSizePolicy(self,
                QSizePolicy.Expanding,
                QSizePolicy.Expanding)
        FigureCanvas.updateGeometry(self)
        self.toolbar = NavigationToolbar(self, self)

        self.button = QPushButton('Plot')


    def plot(self,plotParam,data):#TODO add graphcount
        #plotParam=[[Name,X,Y,color,thickness,linetype,marker,SEM] ...]
        #             0   1 2   3      4         5      6      7

        
        self.ax = self.figure.add_subplot(111)
        self.ax.clear()
        if plotParam == []:
            x = data[0]
            y = data[1]
            yerr = data[2]
            self.ax.errorbar(x,y,yerr,0,marker = 'o',linestyle = '-')
        
        
        else:
            
            self.ax.set_title('%s' %plotParam[0])
            self.ax.set_xlabel('%s' %plotParam[1])
            self.ax.set_ylabel('%s' %plotParam[2])
            
            
            if plotParam[7]==False:
                self.ax.plot(data[0],data[1],plotParam[3],linewidth = int(plotParam[4]),linestyle = plotParam[5],marker = plotParam[6])
            else:
                self.ax.errorbar(data[0],data[1],data[2],0,plotParam[3],linewidth = int(plotParam[4]),linestyle = plotParam[5], marker = plotParam[6])
        
        self.draw()

        """
            if plotParam[k][7] == True: 
                self.ax.errorbar(data[k][3*k],data[k][3*k+1],data[k][3*k+2],0,"color = %s" %plotParam[k][3],"thickness = %s" %plotParam[k][4],"linestyle = %s" %plotParam[k][5],"%s" %plotParam[k][6])
            
            else : 
                self.ax.plot(data[k][3*k],data[k][3*k+1],"color = %s" %plotParam[k][3],"thickness = %s" %plotParam[k][4],"linestyle = %s" %plotParam[k][5],"%s" %plotParam[k][6])
        """


        
class MainWindow(QMainWindow):
    def __init__(self):
        super().__init__()
        
    
        self.interface()
        self.dataDir = ""
        self.plotParam=[]

    def interface(self):
        
        self.startButton = QPushButton("&Start")
        self.startButton.clicked.connect(self.plot)
        
        self.helpButton = QPushButton("&Help")
        self.helpButton.clicked.connect(self.helpWindow)
        
        self.saveButton = QPushButton("&Save")
        self.saveButton.clicked.connect(self.savePlot)
        
        self.quitButton = QPushButton("&Quit")
        self.quitButton.clicked.connect(self.quit)
        
        menubar = self.menuBar()
        fileMenu = menubar.addMenu('&File') 
        openFile = QAction(QIcon('open.png'), 'Open', self) 
        fileMenu.addAction(openFile) 
        openFile.setShortcut('Ctrl+O')
        openFile.setStatusTip('Open new File')
        openFile.triggered.connect(self.getDataFile)
        
        plotOptions = self.menuBar()
        plotMenu = plotOptions.addMenu('&Paramètres du tracé')
        param = QAction('Paramètres',self)
        plotMenu.addAction(param)
        param.triggered.connect(self.paramWindow)
        
        center = QFrame(self)
        center.setFrameShape(QFrame.StyledPanel)
        center.setMinimumSize(600,600)
        self.myPlot = PlotCanvas(center, width=5, height=4, title="Plot")
        
        centerLayout = QHBoxLayout()
        center.setLayout(centerLayout)     
        centerLayout.addWidget(self.myPlot)

        widget = QWidget(self)
        mainLayout = QGridLayout()
        widget.setLayout(mainLayout)
        self.setCentralWidget(widget) 
        
        svqt = QVBoxLayout()
        svqt.addWidget(self.saveButton)
        svqt.addWidget(self.quitButton)
        
        mainLayout.addWidget(menubar,0,0)
        mainLayout.addWidget(self.helpButton,0,2)
        mainLayout.addWidget(center,1,1)
        mainLayout.addLayout(svqt,2,0)
        mainLayout.addWidget(self.startButton,2,2)
        
        self.setWindowTitle("Harry Plotter")
        
    def paramWindow(self):
        
        self.plotwindow = QDialog()
        #Title
        titleLabel = QLabel("Nom du graphe : ")
        self.title = QLineEdit()
        
        #Xname
        xLabel = QLabel("Abscisses : ")
        self.xname = QLineEdit()
        
        #Yname
        yLabel = QLabel("Ordonnées : ")
        self.yname = QLineEdit()
        
        #Color
        colorLabel = QLabel("Choix de la couleur : ")
        self.colorChoice = QComboBox()
        for couleur in ["Bleu","Vert","Rouge","Cyan","Magenta","Jaune","Noir","Blanc"]:
            self.colorChoice.addItem(couleur)
        self.colorChoice.setCurrentIndex(0)
    
        #Thickness
        thicknessLabel = QLabel("Epaisseur du trait : ") #TODO rajouter une sécurité anti-lettres !
        self.thickness = QLineEdit()
        
        #Linetype
        lineLabel = QLabel("Choix du type de tracé : ")
        self.lineChoice = QComboBox()
        for type in ["Normal","Tirets","Tirets + pointillé","Pointillé"]:
            self.lineChoice.addItem(type)
        self.lineChoice.setCurrentIndex(0)

        #Marker
        markerLabel = QLabel("Choix du marqueur : ")
        self.markerChoice = QComboBox()
        for forme in ["Cercle","Carré","Étoile"]:
            self.markerChoice.addItem(forme)
        self.markerChoice.setCurrentIndex(0)

        #SEM toggle
        semLabel = QLabel("Afficher la SEM ? ")
        self.semChoice = QComboBox()
        self.semChoice.addItem("Oui")
        self.semChoice.addItem("Non")
        self.semChoice.setCurrentIndex(0)

        #OK button
        self.okButton = QPushButton("&Valider")
        self.okButton.clicked.connect(self.sendList)
        
        #Les trucs de Layout
        mainLayout = QGridLayout()
        
        mainLayout.addWidget(titleLabel,0,0)
        mainLayout.addWidget(self.title,0,1)
        
        mainLayout.addWidget(xLabel,1,0)
        mainLayout.addWidget(self.xname,1,1)
        
        mainLayout.addWidget(yLabel,2,0)
        mainLayout.addWidget(self.yname,2,1)
        
        mainLayout.addWidget(colorLabel,3,0)
        mainLayout.addWidget(self.colorChoice,3,1)
        
        mainLayout.addWidget(thicknessLabel,4,0)
        mainLayout.addWidget(self.thickness,4,1)
        
        mainLayout.addWidget(lineLabel,5,0)
        mainLayout.addWidget(self.lineChoice,5,1)
        
        mainLayout.addWidget(markerLabel,6,0)
        mainLayout.addWidget(self.markerChoice,6,1)
        
        mainLayout.addWidget(semLabel,7,0)
        mainLayout.addWidget(self.semChoice,7,1)
        
        mainLayout.addWidget(self.okButton,8,3)
        
        self.setWindowTitle("Plot options")
        
        self.plotwindow.setLayout(mainLayout)
        
        self.plotwindow.show()
        
    def sendList(self):

        self.plotParam = []

        #plotParam[0] = title

        self.plotParam.append(self.title.text())
        
        #plotParam[1] = xname
        
        self.plotParam.append(self.xname.text())
        
        #plotParam[2] = yname
        
        self.plotParam.append(self.yname.text())
        
        #plotParam[3] = color

        if self.colorChoice.currentIndex() == 0:
            self.plotParam.append('b')
        if self.colorChoice.currentIndex() == 1:
            self.plotParam.append('g')
        if self.colorChoice.currentIndex() == 2:
            self.plotParam.append('r')
        if self.colorChoice.currentIndex() == 3:
            self.plotParam.append('c')
        if self.colorChoice.currentIndex() == 4:
            self.plotParam.append('m')
        if self.colorChoice.currentIndex() == 5:
            self.plotParam.append('y')
        if self.colorChoice.currentIndex() == 6:
            self.plotParam.append('k')
        if self.colorChoice.currentIndex() == 7:
            self.plotParam.append('w')
        
        #plotParam[4] = thickness
        
        self.plotParam.append(self.thickness.text())
        
        #plotParam[5] = linestyle
        
        if self.lineChoice.currentIndex() == 0:
            self.plotParam.append('-')
        if self.lineChoice.currentIndex() == 1:
            self.plotParam.append('--')
        if self.lineChoice.currentIndex() == 2:
            self.plotParam.append('-.')
        if self.lineChoice.currentIndex() == 3:
            self.plotParam.append(':')
        
        #plotParam[6] = marker
        
        if self.markerChoice.currentIndex() == 0:
            self.plotParam.append('o')
        if self.markerChoice.currentIndex() == 1:
            self.plotParam.append('s')
        if self.markerChoice.currentIndex() == 2:
            self.plotParam.append('*')
        
        #plotParam[7] = sem
        
        if self.semChoice.currentIndex() == 0:
            self.plotParam.append(True)
        if self.semChoice.currentIndex() == 1:
            self.plotParam.append(False)
        
        if self.plotParam[4] == "":
            self.plotParam[4] = "1"

        self.myPlot.plot(self.plotParam,self.data[0])
    
        self.plotwindow.close()

        
    def plot(self):
        
        self.data = dataExtract(self.dataFile[0])
        self.myPlot.plot(self.plotParam,self.data[0])


    def helpWindow(self):
        a=0
        
    def savePlot(self):
        self.saveDirectory = QFileDialog.getExistingDirectory(None, 'Chose where you want to save','/home',QFileDialog.ShowDirsOnly | QFileDialog.DontResolveSymlinks)
        
        if self.plotParam==[]:
            plt.savefig(self.saveDirectory + "/" + "essai.ps", dpi = 1200)
            
        else :
            plt.savefig(self.saveDirectory + "/" + "%s.ps" %self.plotParam[0],format = 'ps', dpi = 1200)
     
    def quit(self):
        mainWindow.close()
        
    def getDataFile(self): 
        self.dataFile = QFileDialog.getOpenFileName(None, 'Select a database folder:', '/home')
        



       
if __name__ == '__main__':
    
    import sys
    
    app = QApplication(sys.argv)
    
    mainWindow = MainWindow()
    mainWindow.show()
    
    sys.exit(app.exec_())
